!Method Declarations for the J & S Slider
!Version 5.0
!Copyright  1998,1997 J & S Software Co. All Rights Reserved
JSSIG           Group, Type  !J & S Slider Init Group. This group is passed to the Init() function.
SliderCTL           Long     !FEQ of the slider (panel)
KnobCTL             Long     !FEQ of the knob
Parent              Short    !FEQ of the parent control
KnobSize            Short    !Size of the knob
Graduations         Byte     !Number of tick marks
TickLock            Byte     !Lock movement to nearest tick mark
TopLeftTicks        Byte     !Draw top or left ticks
BottomRightTicks    Byte     !Draw bottom right ticks
GradSize            Byte     !Size of the tick marks
AdjustOK            Byte     !Okay to adjust slider size to allow for consistant Tick Marks
SheetControl        Long
LargeScroll         DECIMAL(12,2)     !Large scroll (Scroll distance when Page up/Page down/Mouse Click on slider)
SmallScroll         DECIMAL(12,2)     !Small scroll (Scroll distance when arrow keys used)
ToolTip             String( 100 )
MSG                 String( 100 )
                end

SliderClass  class, type, Module('jsslid50.clw')   !Generic Slider Class
PreInit        Procedure, Virtual                                                   !Initializes the INIT function
Init           Function( ? InitValue, ? SliderMax , ? SliderMin , *JSSIG IG ) !Initializes the slider
Kill           Procedure                                                            !Does nothing right now
EventHandler   Function( *? SliderUse ), Byte                                       !Manages all events
Sync           Procedure( ? InitValue ), Virtual                                    !Syncronizes slider to existing value
MousePos       Function(), Long, Virtual                                            !Either MouseX() or MouseY()
SliderVal      Function(), Real, Virtual                                            !Returns the value based on knob position
SetToPosition  Procedure( Long NewPos ), Virtual                                    !Sets the positions of all moveable controls
CreateCTLS     Procedure(*JSSIG IG), Virtual                                        !Called by INIT() to create extra window controls
Select         Procedure                                                            !Used instead of SELECT() to select the slider
Field          Function(), LONG                                                     !Returns a field number if part of slider
KeyEvent       Procedure                                                            !Handles all keyboard activity for slider
ClickEvent     Procedure                                                            !Handles mouse clicks
Graduate       Procedure, Virtual                                                   !Draws the "tick marks"
SelectBox      Procedure                                                            !Draws (and clears) the "Selected" dotted lines
CheckRange     Procedure( *SHORT NewPos )                                               !Makes sure that the new position is within acceptable range
m_SliderMax           Real   !Upper limit of Slider value
m_SliderMin           Real   !Lower Limit of slider value
m_SliderMinPos        Short  !X or Y Position
m_SliderMaxPos        Short  !X or Y Position
m_SliderCtl           Short  !Field Number of the control
m_KnobCtl             Short  !field number of the knob
m_KnobColor           Long   !Color of the knob
m_KnobCenter          Short  !Offset for the center of the knob
m_IsSliding           Byte   !Currently sliding
m_MouseOffset         Short  !X or Y Position
m_SizeProp            Short  !Height or Width
m_PosProp             Short  !X or Y Position
m_SelectCTL           Short  !Entry control to Select()
m_ClickCTL            Short  !Handles mouse clicks
m_Graduations         byte   !Number of graduations
m_TickLock            byte   !Lock movement to nearest tick mark
m_TopLeftTicks        byte   !Draw top or left ticks
m_BottomRightTicks    byte   !Draw bottom right ticks
m_GradSize            byte   !Size of the tick marks
m_Pixels              byte   !saves the status of PROP:Pixels
m_LargeUnits          DECIMAL(12,2)   !Large Scroll
m_SmallUnits          DECIMAL(12,2)   !Small Scroll
m_SheetControl        long
m_IsVisible           byte   ! Is the focus box showing?
             end

HSlider:Class class( SliderClass ), type, Module('jsslid50.clw')    !Horizontal
PreInit        Procedure, Virtual
Sync           Procedure( ? InitValue ), Virtual
MousePos       Function(), Long, Virtual
SetToPosition  Procedure( Long NewPos ), Virtual
SliderVal      Function(), Real, Virtual
CreateCTLS     Procedure(*JSSIG IG), Virtual
Graduate       Procedure, Virtual
             end
VSlider:Class class( SliderClass ), type, Module('jsslid50.clw')    !Vertical
PreInit        Procedure, Virtual
Sync           Procedure( ? InitValue ), Virtual
MousePos       Function(), Long, Virtual
SetToPosition  Procedure( Long NewPos ), Virtual
SliderVal      Function(), Real, Virtual
CreateCTLS     Procedure(*JSSIG IG), Virtual
Graduate       Procedure, Virtual
             end
jsPOINT        GROUP,TYPE
X                SIGNED
Y                SIGNED
                END
